<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (34)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="optional-chaining-.">Optional chaining ‘?.’</h1>
    <p>[recent browser=“new”]</p>
    <p>
      The optional chaining <code>?.</code> is a safe way to access nested
      object properties, even if an intermediate property doesn’t exist.
    </p>
    <h2 id="the-non-existing-property-problem">
      The “non-existing property” problem
    </h2>
    <p>
      If you’ve just started to read the tutorial and learn JavaScript, maybe
      the problem hasn’t touched you yet, but it’s quite common.
    </p>
    <p>
      As an example, let’s say we have <code>user</code> objects that hold the
      information about our users.
    </p>
    <p>
      Most of our users have addresses in <code>user.address</code> property,
      with the street <code>user.address.street</code>, but some did not provide
      them.
    </p>
    <p>
      In such case, when we attempt to get <code>user.address.street</code>, and
      the user happens to be without an address, we get an error:
    </p>
    <p>```js run let user = {}; // a user without “address” property</p>
    <p>alert(user.address.street); // Error! ```</p>
    <p>
      That’s the expected result. JavaScript works like this. As
      <code>user.address</code> is <code>undefined</code>, an attempt to get
      <code>user.address.street</code> fails with an error.
    </p>
    <p>
      In many practical cases we’d prefer to get <code>undefined</code> instead
      of an error here (meaning “no street”).
    </p>
    <p>
      …And another example. In the web development, we can get an object that
      corresponds to a web page element using a special method call, such as
      <code>document.querySelector('.elem')</code>, and it returns
      <code>null</code> when there’s no such element.
    </p>
    <p>
      <code
        >js run // document.querySelector('.elem') is null if there's no element
        let html = document.querySelector(".elem").innerHTML; // error if it's
        null</code
      >
    </p>
    <p>
      Once again, if the element doesn’t exist, we’ll get an error accessing
      <code>.innerHTML</code> of <code>null</code>. And in some cases, when the
      absence of the element is normal, we’d like to avoid the error and just
      accept <code>html = null</code> as the result.
    </p>
    <p>How can we do this?</p>
    <p>
      The obvious solution would be to check the value using <code>if</code> or
      the conditional operator <code>?</code>, before accessing its property,
      like this:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> user <span class="op">=</span> <span class="op">{};</span></a>
<a class="sourceLine" id="cb1-2" title="2"></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="at">alert</span>(<span class="va">user</span>.<span class="at">address</span> <span class="op">?</span> <span class="va">user</span>.<span class="va">address</span>.<span class="at">street</span> : <span class="kw">undefined</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      It works, there’s no error… But it’s quite inelegant. As you can see, the
      <code>"user.address"</code> appears twice in the code. For more deeply
      nested properties, that becomes a problem as more repetitions are
      required.
    </p>
    <p>E.g. let’s try getting <code>user.address.street.name</code>.</p>
    <p>
      We need to check both <code>user.address</code> and
      <code>user.address.street</code>:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> user <span class="op">=</span> <span class="op">{};</span> <span class="co">// user has no address</span></a>
<a class="sourceLine" id="cb2-2" title="2"></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="at">alert</span>(</a>
<a class="sourceLine" id="cb2-4" title="4">  <span class="va">user</span>.<span class="at">address</span> <span class="op">?</span> (<span class="va">user</span>.<span class="va">address</span>.<span class="at">street</span> <span class="op">?</span> <span class="va">user</span>.<span class="va">address</span>.<span class="va">street</span>.<span class="at">name</span> : <span class="kw">null</span>) : <span class="kw">null</span></a>
<a class="sourceLine" id="cb2-5" title="5">)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      That’s just awful, one may even have problems understanding such code.
    </p>
    <p>
      Don’t even care to, as there’s a better way to write it, using the
      <code>&amp;&amp;</code> operator:
    </p>
    <p>```js run let user = {}; // user has no address</p>
    <p>
      alert(user.address &amp;&amp; user.address.street &amp;&amp;
      user.address.street.name); // undefined (no error) ```
    </p>
    <p>
      AND’ing the whole path to the property ensures that all components exist
      (if not, the evaluation stops), but also isn’t ideal.
    </p>
    <p>
      As you can see, property names are still duplicated in the code. E.g. in
      the code above, <code>user.address</code> appears three times.
    </p>
    <p>
      That’s why the optional chaining <code>?.</code> was added to the
      language. To solve this problem once and for all!
    </p>
    <h2 id="optional-chaining">Optional chaining</h2>
    <p>
      The optional chaining <code>?.</code> stops the evaluation if the value
      before <code>?.</code> is <code>undefined</code> or <code>null</code> and
      returns <code>undefined</code>.
    </p>
    <p>
      <strong
        >Further in this article, for brevity, we’ll be saying that something
        “exists” if it’s not <code>null</code> and not
        <code>undefined</code>.</strong
      >
    </p>
    <p>In other words, <code>value?.prop</code>:</p>
    <ul>
      <li>works as <code>value.prop</code>, if <code>value</code> exists,</li>
      <li>
        otherwise (when <code>value</code> is <code>undefined/null</code>) it
        returns <code>undefined</code>.
      </li>
    </ul>
    <p>
      Here’s the safe way to access <code>user.address.street</code> using
      <code>?.</code>:
    </p>
    <p>```js run let user = {}; // user has no address</p>
    <p>alert(user?.address?.street); // undefined (no error) ```</p>
    <p>The code is short and clean, there’s no duplication at all.</p>
    <p>
      Reading the address with <code>user?.address</code> works even if
      <code>user</code> object doesn’t exist:
    </p>
    <p>```js run let user = null;</p>
    <p>
      alert(user?.address); // undefined alert(user?.address.street); //
      undefined ```
    </p>
    <p>
      Please note: the <code>?.</code> syntax makes optional the value before
      it, but not any further.
    </p>
    <p>
      E.g. in <code>user?.address.street.name</code> the <code>?.</code> allows
      <code>user</code> to safely be <code>null/undefined</code> (and returns
      <code>undefined</code> in that case), but that’s only for
      <code>user</code>. Further properties are accessed in a regular way. If we
      want some of them to be optional, then we’ll need to replace more
      <code>.</code> with <code>?.</code>.
    </p>
    <p>
      ``<code
        >warn header="Don't overuse the optional chaining" We should use</code
      >?.` only where it’s ok that something doesn’t exist.
    </p>
    <p>
      For example, if according to our coding logic <code>user</code> object
      must exist, but <code>address</code> is optional, then we should write
      <code>user.address?.street</code>, but not
      <code>user?.address?.street</code>.
    </p>
    <p>
      So, if <code>user</code> happens to be undefined due to a mistake, we’ll
      see a programming error about it and fix it. Otherwise, coding errors can
      be silenced where not appropriate, and become more difficult to debug. ```
    </p>
    <p>
      ```<code>warn header="The variable before</code>?.<code
        >must be declared" If there's no variable</code
      >user<code>at all, then</code>user?.anything` triggers an error:
    </p>
    <p>
      <code>js run // ReferenceError: user is not defined user?.address;</code>
    </p>
    <p>
      The variable must be declared (e.g. <code>let/const/var user</code> or as
      a function parameter). The optional chaining works only for declared
      variables.
    </p>
    <pre><code>
## Short-circuiting

As it was said before, the `?.` immediately stops (&quot;short-circuits&quot;) the evaluation if the left part doesn&#39;t exist.

So, if there are any further function calls or side effects, they don&#39;t occur.

For instance:

```js run
let user = null;
let x = 0;

user?.sayHi(x++); // no &quot;sayHi&quot;, so the execution doesn&#39;t reach x++

alert(x); // 0, value not incremented
```

## Other variants: ?.(), ?.[]

The optional chaining `?.` is not an operator, but a special syntax construct, that also works with functions and square brackets.

For example, `?.()` is used to call a function that may not exist.

In the code below, some of our users have `admin` method, and some don&#39;t:

```js run
let userAdmin = {
  admin() {
    alert(&quot;I am admin&quot;);
  }
};

let userGuest = {};

*!*
userAdmin.admin?.(); // I am admin
*/!*

*!*
userGuest.admin?.(); // nothing (no such method)
*/!*
```

Here, in both lines we first use the dot (`userAdmin.admin`) to get `admin` property, because we assume that the user object exists, so it&#39;s safe read from it.

Then `?.()` checks the left part: if the admin function exists, then it runs (that&#39;s so for `userAdmin`). Otherwise (for `userGuest`) the evaluation stops without errors.

The `?.[]` syntax also works, if we&#39;d like to use brackets `[]` to access properties instead of dot `.`. Similar to previous cases, it allows to safely read a property from an object that may not exist.

```js run
let key = &quot;firstName&quot;;

let user1 = {
  firstName: &quot;John&quot;
};

let user2 = null;

alert( user1?.[key] ); // John
alert( user2?.[key] ); // undefined
```

Also we can use `?.` with `delete`:

```js run
delete user?.name; // delete user.name if user exists
```

````warn header=&quot;We can use `?.` for safe reading and deleting, but not writing&quot;
The optional chaining `?.` has no use at the left side of an assignment.

For example:
```js run
let user = null;

user?.name = &quot;John&quot;; // Error, doesn&#39;t work
// because it evaluates to undefined = &quot;John&quot;
```

It&#39;s just not that smart.</code></pre>
    <h2 id="summary">Summary</h2>
    <p>The optional chaining <code>?.</code> syntax has three forms:</p>
    <ol type="1">
      <li>
        <code>obj?.prop</code> – returns <code>obj.prop</code> if
        <code>obj</code> exists, otherwise <code>undefined</code>.
      </li>
      <li>
        <code>obj?.[prop]</code> – returns <code>obj[prop]</code> if
        <code>obj</code> exists, otherwise <code>undefined</code>.
      </li>
      <li>
        <code>obj.method?.()</code> – calls <code>obj.method()</code> if
        <code>obj.method</code> exists, otherwise returns
        <code>undefined</code>.
      </li>
    </ol>
    <p>
      As we can see, all of them are straightforward and simple to use. The
      <code>?.</code> checks the left part for <code>null/undefined</code> and
      allows the evaluation to proceed if it’s not so.
    </p>
    <p>A chain of <code>?.</code> allows to safely access nested properties.</p>
    <p>
      Still, we should apply <code>?.</code> carefully, only where it’s
      acceptable that the left part doesn’t exist. So that it won’t hide
      programming errors from us, if they occur.
    </p>
  </body>
</html>
